Index: pjproject/trunk/pjsip-apps/src/pjsua/pjsua_app_cli.c
===================================================================
--- pjproject/trunk/pjsip-apps/src/pjsua/pjsua_app_cli.c	(revision 4826)
+++ pjproject/trunk/pjsip-apps/src/pjsua/pjsua_app_cli.c	(revision 5170)
@@ -1749,7 +1749,7 @@
 	    }
 	} else if (result.uri_result) {
-	    pj_str_t tmp;
-	    tmp = pj_str(result.uri_result);
-	    pjsua_call_xfer( current_call, &tmp, &msg_data);
+	    pj_str_t tmp2;
+	    tmp2 = pj_str(result.uri_result);
+	    pjsua_call_xfer( current_call, &tmp2, &msg_data);
 	}
     }
@@ -1769,5 +1769,5 @@
 	pj_str_t STR_FALSE = { "false", 5 };
 	pjsua_call_id ids[PJSUA_MAX_CALLS];
-	pjsua_msg_data msg_data;
+	pjsua_msg_data msg_data_;
 	char buf[8] = {0};
 	pj_str_t tmp = pj_str(buf);
@@ -1823,15 +1823,15 @@
 	}
 
-	pjsua_msg_data_init(&msg_data);
+	pjsua_msg_data_init(&msg_data_);
 	if (app_config.no_refersub) {
 	    /* Add Refer-Sub: false in outgoing REFER request */
 	    pjsip_generic_string_hdr_init2(&refer_sub, &STR_REFER_SUB,
 					   &STR_FALSE);
-	    pj_list_push_back(&msg_data.hdr_list, &refer_sub);
+	    pj_list_push_back(&msg_data_.hdr_list, &refer_sub);
 	}
 
 	pjsua_call_xfer_replaces(call, dst_call,
 				 PJSUA_XFER_NO_REQUIRE_REPLACES,
-				 &msg_data);
+				 &msg_data_);
     }
     return PJ_SUCCESS;
@@ -2662,5 +2662,5 @@
 }
 
-static pj_status_t add_call_command(pj_cli_t *cli)
+static pj_status_t add_call_command(pj_cli_t *c)
 {
     char* call_command =
@@ -2734,10 +2734,10 @@
 
     pj_str_t xml = pj_str(call_command);
-    return pj_cli_add_cmd_from_xml(cli, NULL,
+    return pj_cli_add_cmd_from_xml(c, NULL,
 				   &xml, cmd_call_handler,
 				   NULL, get_choice_value);
 }
 
-static pj_status_t add_presence_command(pj_cli_t *cli)
+static pj_status_t add_presence_command(pj_cli_t *c)
 {
     char* presence_command =
@@ -2790,10 +2790,10 @@
     pj_str_t xml = pj_str(presence_command);
 
-    return pj_cli_add_cmd_from_xml(cli, NULL,
+    return pj_cli_add_cmd_from_xml(c, NULL,
 				   &xml, cmd_presence_handler,
 				   NULL, get_choice_value);
 }
 
-static pj_status_t add_account_command(pj_cli_t *cli)
+static pj_status_t add_account_command(pj_cli_t *c)
 {
     char* account_command =
@@ -2835,10 +2835,10 @@
 
     pj_str_t xml = pj_str(account_command);
-    return pj_cli_add_cmd_from_xml(cli, NULL,
+    return pj_cli_add_cmd_from_xml(c, NULL,
 				   &xml, cmd_account_handler,
 				   NULL, get_choice_value);
 }
 
-static pj_status_t add_media_command(pj_cli_t *cli)
+static pj_status_t add_media_command(pj_cli_t *c)
 {
     char* media_command =
@@ -2870,10 +2870,10 @@
 
     pj_str_t xml = pj_str(media_command);
-    return pj_cli_add_cmd_from_xml(cli, NULL,
+    return pj_cli_add_cmd_from_xml(c, NULL,
 				   &xml, cmd_media_handler,
 				   NULL, get_choice_value);
 }
 
-static pj_status_t add_config_command(pj_cli_t *cli)
+static pj_status_t add_config_command(pj_cli_t *c)
 {
     char* config_command =
@@ -2891,5 +2891,5 @@
 
     pj_str_t xml = pj_str(config_command);
-    return pj_cli_add_cmd_from_xml(cli, NULL,
+    return pj_cli_add_cmd_from_xml(c, NULL,
 				   &xml, cmd_config_handler,
 				   NULL, get_choice_value);
@@ -3042,5 +3042,5 @@
 #endif
 
-static pj_status_t add_other_command(pj_cli_t *cli)
+static pj_status_t add_other_command(pj_cli_t *c)
 {
     char* sleep_command =
@@ -3069,5 +3069,5 @@
     pj_str_t restart_xml = pj_str(restart_command);
 
-    status = pj_cli_add_cmd_from_xml(cli, NULL,
+    status = pj_cli_add_cmd_from_xml(c, NULL,
 				     &sleep_xml, cmd_sleep_handler,
 				     NULL, NULL);
@@ -3075,5 +3075,5 @@
 	return status;
 
-    status = pj_cli_add_cmd_from_xml(cli, NULL,
+    status = pj_cli_add_cmd_from_xml(c, NULL,
 				     &network_xml, cmd_network_handler,
 				     NULL, NULL);
@@ -3081,5 +3081,5 @@
 	return status;
 
-    status = pj_cli_add_cmd_from_xml(cli, NULL,
+    status = pj_cli_add_cmd_from_xml(c, NULL,
 				     &shutdown_xml, cmd_quit_handler,
 				     NULL, NULL);
@@ -3088,5 +3088,5 @@
 	return status;
 
-    status = pj_cli_add_cmd_from_xml(cli, NULL,
+    status = pj_cli_add_cmd_from_xml(c, NULL,
 				     &restart_xml, cmd_restart_handler,
 				     NULL, NULL);
@@ -3095,35 +3095,35 @@
 }
 
-pj_status_t cli_setup_command(pj_cli_t *cli)
+pj_status_t cli_setup_command(pj_cli_t *c)
 {
     pj_status_t status;
 
-    status = add_call_command(cli);
+    status = add_call_command(c);
     if (status != PJ_SUCCESS)
 	return status;
 
-    status = add_presence_command(cli);
+    status = add_presence_command(c);
     if (status != PJ_SUCCESS)
 	return status;
 
-    status = add_account_command(cli);
+    status = add_account_command(c);
     if (status != PJ_SUCCESS)
 	return status;
 
-    status = add_media_command(cli);
+    status = add_media_command(c);
     if (status != PJ_SUCCESS)
 	return status;
 
-    status = add_config_command(cli);
+    status = add_config_command(c);
     if (status != PJ_SUCCESS)
 	return status;
 
 #if PJSUA_HAS_VIDEO
-    status = add_video_command(cli);
+    status = add_video_command(c);
     if (status != PJ_SUCCESS)
 	return status;
 #endif
 
-    status = add_other_command(cli);
+    status = add_other_command(c);
 
     return status;